// NOTE:
//
// Some operations require special permissions.
// Terminal Services Permissions. To modify permissions on a
// session, use the Terminal Services Configuration
// administrative tool.

unit tsutil;

interface

uses windows;

type Handle = longint;

     {$EXTERNALSYM WTS_CONNECTSTATE_CLASS}
     WTS_CONNECTSTATE_CLASS = ( WTSActive, WTSConnected, WTSConnectQuery, WTSShadow,
                                WTSDisconnected, WTSIdle, WTSListen, WTSReset, WTSDown,
                                WTSInit
                              );

     {$EXTERNALSYM WTS_INFO_CLASS}
     WTS_INFO_CLASS = ( WTSInitialProgram, WTSApplicationName, WTSWorkingDirectory,
                        WTSOEMId, WTSSessionId, WTSUserName, WTSWinStationName, WTSDomainName,
                        WTSConnectState, WTSClientBuildNumber, WTSClientName, WTSClientDirectory,
                        WTSClientProductId, WTSClientHardwareId, WTSClientAddress, WTSClientDisplay,
                        WTSClientProtocolType
                      );

     {$EXTERNALSYM WTS_SESSION_INFO}
     WTS_SESSION_INFO = record
       SessionId:dword;
       pWinStationName:LPTSTR;
       State:WTS_CONNECTSTATE_CLASS;
     end;
     {$EXTERNALSYM PWTS_SESSION_INFO}
     PWTS_SESSION_INFO=^WTS_SESSION_INFO;

const
  {$EXTERNALSYM WTS_CURRENT_SERVER_HANDLE}
  WTS_CURRENT_SERVER_HANDLE : Handle = 0;

  SessionStateStrings:array[WTS_CONNECTSTATE_CLASS] of string = ('WTSActive', 'WTSConnected',
                                'WTSConnectQuery', 'WTSShadow', 'WTSDisconnected', 'WTSIdle',
                                'WTSListen', 'WTSReset', 'WTSDown', 'WTSInit');

{$EXTERNALSYM WTSEnumerateSessions}
function WTSEnumerateSessions(
             hServer:Handle;
             Reserved:dword;// must be 0
             Version:dword;// must be 1
             var SessionInfo:PWTS_SESSION_INFO;
             var Count:dword
         ):boolean; stdcall;

{$EXTERNALSYM WTSFreeMemory}
procedure WTSFreeMemory(
              memory:pointer
          ); stdcall;

{$EXTERNALSYM WTSQuerySessionInformation}
function WTSQuerySessionInformation(
             hServer:Handle;
             SessionId:dword;
             WTSInfoClass:WTS_INFO_CLASS;
             var pBuffer:LPTSTR;
             var bytesReturned:dword
         ):boolean; stdcall;

implementation

function WTSEnumerateSessions; external 'wtsapi32.dll' name 'WTSEnumerateSessionsA';
procedure WTSFreeMemory; external 'wtsapi32.dll' name 'WTSFreeMemory';
function WTSQuerySessionInformation; external 'wtsapi32.dll' name 'WTSQuerySessionInformationA';

end.
